package sorting;

import edu.neu.ccs.console.*;
import edu.neu.ccs.gui.*;

/** 
 * An input channel to collect the time trial selections from the GUI input.
 *  
 * @since 17 March 2004
 * @author Viera K. Proulx*/
class GUITimerInput implements ConsoleAware{
 
  /** The view used to provide and display the <code>Balloon</code> data */
  TimerInputView timerGUI;

  /** The constructor */
  GUITimerInput(){		
    
    // build the GUI for the input of one set of timer settings
    this.timerGUI = new TimerInputView();
    GeneralDialog.showOKDialog(this.timerGUI, "Timer Tests");
  }
  
  /**
   * Demand the values for the settings for the timer tests: 
   * which algorithms to test, what data sizes to use, 
   * what comparators to use 
   * Report errors and re-try till successful.
   */
  public boolean[][] demandTimerInputs(){
    return this.timerGUI.demandTimerData();
  }
}
