package sorting;

import edu.neu.ccs.*;
import edu.neu.ccs.jpf.*;

/**
 * 
 * @(#)Interactions.java 1.0  20 September 2004
 * Revised 30 March 2010
 */
public class Interactions extends JPF {
  /** an instance of the <code>Algorithms</code> class for explorations */
  public Algorithms algos;

  /** The object that records the test we want to run */
  public TimerTests timertests;

  public static void main(String[] args) { 
    // To optionally adjust the look and feel,
    // remove the comments from one of the two statements below.

    // LookAndFeelTools.showSelectLookAndFeelDialog();
    // LookAndFeelTools.adjustAllDefaultFontSizes(2);

    new Interactions();
  }

  ///////////////////////////////////////////////////////////
  // Place your actual methods here.                       //
  ///////////////////////////////////////////////////////////
  /*----------------------------------------------------------------------- 
	 Explore city constructors
	------------------------------------------------------------------------- */
  /**
   * Explore and show how the constructors for the 
   * <code>City</code> class work and see how the data is read
   * from the console.
   */
  public void cityConstructors(){

    City nyc = new City();
    console.out.println(nyc);

    City boston = new City(02115, "Boston", "MA", 78.123345, 40.987654);
    console.out.println(boston);

    City bos = new City(boston);
    console.out.println(bos);

    console.out.println("Testing zip code converter");
    console.out.println(12345 == boston.decimal("12345"));

    console.out.println(2145 == boston.decimal("02145"));
  }


  /*----------------------------------------------------------------------- 
	 Read input file that contains a list of cities: initialize timertests
	------------------------------------------------------------------------- */
  /**
   * Build a new <code>TimerTests</code> instance and read in the data.
   */
  public void FileInput(){ 
    this.timertests = new TimerTests();
    console.out.println("Read " + 
        this.timertests.alldata.size() + " data items");
  }


  /*----------------------------------------------------------------------- 
	 Explore console channel and iterator for input of list of cities
	------------------------------------------------------------------------- */
  /**
   * Select which algorithms, data sizes, and comparators should be timed.
   */
  public void TimerInput(){

    if (this.timertests == null)
      console.out.println("You must first read in the data for the tests");
    else
      this.timertests.initAll();
  }

  /*----------------------------------------------------------------------- 
	 Explore algorithms class skeleton
	------------------------------------------------------------------------- */
  /**
   * Run the actual timer tests as selected in <code>TimerInput</code> method
   */
  public void RunTests(){

    if (this.timertests.sortAlgos.isEmpty())
      console.out.println("You must choose at least one algorithm");

    if (this.timertests.comparators.isEmpty())
      console.out.println("You must choose at least one comparator");

    if (this.timertests.dataSizes.isEmpty())
      console.out.println("You must select at least one data size choice");

    if (!(this.timertests.sortAlgos.isEmpty()) && 
        !(this.timertests.comparators.isEmpty()) &&
        !(this.timertests.dataSizes.isEmpty())){

      this.timertests.runAllTests();
      console.out.println("\nTests completed");
    }

  }


  /*----------------------------------------------------------------------- 
	 Helper method
	------------------------------------------------------------------------- */
  /** convert a String to int - if possible */
  protected int intValue(String s){
    int n = 0;
    try{
      n = (new XInt(s)).intValue();
    }
    catch(java.text.ParseException e){
      console.out.println("Cannot convert " + s + " to integer.");
    }
    return n;
  }
}

